Attribute VB_Name = "ExprSolver"
Option Explicit
Dim ExprLen&, Expr(65535) As Byte, EF(65535) As Byte, L1&, L2&, ResultLen&, Result(65535) As Byte, ValidResult As Byte
Dim RsltLen&, Rslt(65535) As Byte
Public XVar$
Private Sub Solve() '   - -   
'If Listing Then
'  On Error Resume Next
'Else
'  On Error GoTo Errx
'End If
On Error GoTo Errx
Dim I&, C As Byte, MaxPrior&, MaxPPos&, A&, Opp$, R As Double, Op1 As Double, Op2 As Double, cR$
ValidResult = 1
RsltLen = ExprLen
CopyMemory Rslt(0), Expr(0), ExprLen
FindEF
TrimExpr
FindEF
EliminateConstants
FindEF
Do
  EliminateBrackets
  FindEF
  
  MaxPrior = -2
  For I = 0 To RsltLen - 1
    If EF(I) = 2 Then
      A = GetOperPrior(I)
      If A > MaxPrior Then
        MaxPrior = A
        MaxPPos = I
      End If
    End If
  Next I
  If MaxPrior = -2 Then Exit Do
  Opp = GetOper(MaxPPos)
  Op1 = GetOperand1(MaxPPos)
  Op2 = GetOperand2(MaxPPos)
  Select Case Opp
  Case "+"
    R = Op1 + Op2
  Case "-"
    R = Op1 - Op2
  Case "%"
    If Op2 <> 0 Then R = FMod(Op1, Op2) Else R = 0
  Case "*"
    R = Op1 * Op2
  Case "/"
    If Op2 <> 0 Then R = Op1 / Op2 Else R = 0
  Case "^"
    R = Op1 ^ Op2
  Case "=="
    If Op1 = Op2 Then R = 1 Else R = 0
  Case ">"
    If Op1 > Op2 Then R = 1 Else R = 0
  Case "<"
    If Op1 < Op2 Then R = 1 Else R = 0
  Case ">="
    If Op1 >= Op2 Then R = 1 Else R = 0
  Case "<="
    If Op1 <= Op2 Then R = 1 Else R = 0
  Case "!="
    If Op1 <> Op2 Then R = 1 Else R = 0
  Case "&&"
    R = CDbl(SafeInt(Op1) And SafeInt(Op2))
  Case "||"
    R = CDbl(SafeInt(Op1) Or SafeInt(Op2))
  Case "^^"
    R = CDbl(SafeInt(Op1) Xor SafeInt(Op2))
  Case "["
    R = FMin(Op1, Op2)
  Case "]"
    R = FMax(Op1, Op2)
  Case Else
    GoTo Errx
  End Select
  'cR = CStr(R)
  cR = Trim(Str(R))
  DelString L1, L2 - L1 + 1
  InsString L1, cR
  FindEF
Loop
Exit Sub
Errx:
ValidResult = 0
End Sub

Private Sub TrimExpr()
Dim I&, S$
I = 0
Do While I < RsltLen
  If Rslt(I) <= 32 Then
    DelChar I
  Else
    I = I + 1
  End If
Loop
End Sub

Private Sub DelString(F&, N&)
Dim I&
RsltLen = RsltLen - N
For I = F To RsltLen - 1
  Rslt(I) = Rslt(I + N)
Next I
End Sub
Private Sub DelStringFill(F&)
Dim I&, N&
For I = F To RsltLen - 1
  If EF(I) = EF(F) Then N = N + 1 Else Exit For
Next I
RsltLen = RsltLen - N
For I = F To RsltLen - 1
  Rslt(I) = Rslt(I + N)
Next I
End Sub
Private Sub InsString(F&, S$)
Dim I&, D&
RsltLen = RsltLen + Len(S)
For I = RsltLen - 1 To F + Len(S) Step -1
  Rslt(I) = Rslt(I - Len(S))
  EF(I) = EF(I - Len(S))
Next I
D = 1
For I = F To F + Len(S) - 1
  Rslt(I) = Asc(Mid(S, D, 1))
  D = D + 1
Next I
End Sub
Private Sub DelChar(P&)
Dim I&
RsltLen = RsltLen - 1
For I = P To RsltLen - 1
  Rslt(I) = Rslt(I + 1)
  EF(I) = EF(I + 1)
Next I
End Sub
Private Sub EliminateConstants()
Dim I&, S$
I = 0
Do While I < RsltLen
  If EF(I) = 5 Then
    S = GetBlock(I)
    Select Case LCase(S)
    Case "pi"
      DelStringFill I
      InsString I, "3.14159265358979"
      FindEF
    Case "x"
      DelStringFill I
      InsString I, XVar
      FindEF
    Case "e"
      DelStringFill I
      InsString I, "2.71828182845905"
      FindEF
    Case "rnd"
      DelStringFill I
      InsString I, CStr(Rnd)
      FindEF
    Case Else
      DelStringFill I
      InsString I, "0"
      FindEF
    End Select
    If I > 0 Then
      If Rslt(I) = 45 And Rslt(I - 1) = 45 Then
        DelChar I - 1
        DelChar I - 1
      End If
    End If
  End If
  I = I + 1
Loop
End Sub
Private Sub EliminateBrackets()
Dim I&, C As Byte, G As Byte, P&, J&, S$, B As Byte, R As Double
Do
  B = 0
  I = 0
  Do
    If C Then
      If Rslt(I) = 40 Then
        P = I: C = 1: G = 1
      ElseIf Rslt(I) = 41 Then
        C = 0
        If G Then
          S = ""
          For J = P - 1 To 0 Step -1
            If EF(J) = 4 Then S = S & Chr(Rslt(J)) Else Exit For
          Next J
          S = StrReverse(S)
          DelChar I
          DelChar P
          B = 1
          If Len(S) Then
            R = GetNumber(P)
            DelStringFill P: FindEF
            Select Case LCase(S)
            Case "sin"
              R = Sin(R)
            Case "cos"
              R = Cos(R)
            Case "tan"
              R = Tan(R)
            Case "atn", "arctan"
              R = Atn(R)
            Case "abs"
              R = Abs(R)
            Case "int"
              R = Int(R)
            Case "log"
              If R <= 0 Then R = 0: ValidResult = 0 Else R = Log(R)
            Case "exp"
              R = Exp(R)
            Case "sgn"
              R = Sgn(R)
            Case "sqr", "sqrt"
              If R < 0 Then R = 0: ValidResult = 0 Else R = Sqr(R)
            Case "asin", "arcsin"
              If R < -1 Or R > 1 Then R = 0: ValidResult = 0 Else R = ASin(R)
            Case "acos", "arccos"
              If R < -1 Or R > 1 Then R = 0: ValidResult = 0 Else R = ACos(R)
            Case "degtorad", "dtr"
              R = dDegToRad(R)
            Case "radtodeg", "rtd"
              R = dRadToDeg(R)
            Case "not"
              R = CDbl(Not CLng(Int(R)))
            End Select
            InsString P, Trim(Str(R))
            DelStringFill J + 1: FindEF
          End If
          I = I - 2
        End If
      ElseIf EF(I) = 2 Then
        If I = P And Rslt(I) = 45 Then Else G = 0
      End If
    Else
      If Rslt(I) = 40 Then P = I: C = 1: G = 1
    End If
    I = I + 1
  Loop While I < RsltLen
  If B = 0 Then Exit Do
Loop
End Sub
Private Function GetOper(P&) As String
If EF(P + 1) = 2 Then
  If EF(P + 2) = 2 Then
    GetOper = Chr(Rslt(P)) & Chr(Rslt(P + 1)) & Chr(Rslt(P + 2))
  Else
    GetOper = Chr(Rslt(P)) & Chr(Rslt(P + 1))
  End If
Else
  GetOper = Chr(Rslt(P))
End If
End Function
Private Function GetNumber(P&) As Double
Dim I&, S$
For I = P To RsltLen - 1
  If EF(I) <> 1 Then Exit For
  S = S & Chr(Rslt(I))
Next I
If Len(S) Then GetNumber = Val(S)
End Function
Private Function GetBlock(P&) As String
Dim I&, S$
For I = P To RsltLen - 1
  If EF(I) <> EF(P) Then Exit For
  S = S & Chr(Rslt(I))
Next I
GetBlock = S
End Function
Private Function GetOperand1(P&) As Double
Dim I&, S$
For I = P - 1 To 0 Step -1
  If EF(I) <> 1 Then
    L1 = I + 1
    Exit For
  End If
  S = S & Chr(Rslt(I))
Next I
If Len(S) Then
  S = StrReverse(S)
  'GetOperand1 = CDbl(S)
  GetOperand1 = Val(S)
End If
If I = -1 Then L1 = 0
End Function
Private Function GetOperand2(P&) As Double
Dim I&, S&, D&, T$
For I = P To RsltLen - 1
  If EF(I) = 1 Then S = I: Exit For
Next I
For I = S To RsltLen - 1
  If EF(I) <> 1 Then D = I - 1: Exit For
Next I
If I = RsltLen Then D = RsltLen - 1
For I = S To D
  T = T & Chr(Rslt(I))
Next I
If Len(S) = 0 Then
  GetOperand2 = 0
  L2 = P
Else
  GetOperand2 = Val(T)
End If
L2 = D
End Function
Private Function GetOperPrior(P&) As Long
Dim I&, Opp$
Opp = GetOper(P)
Select Case Opp
Case "&&", "||", "^^"
  GetOperPrior = 0
Case "==", ">", "<", ">=", "<=", "!="
  GetOperPrior = 1
Case "+", "-"
  GetOperPrior = 2
Case "%"
  GetOperPrior = 3
Case "*", "/"
  GetOperPrior = 4
Case "^", "[", "]"
  GetOperPrior = 5
End Select
For I = P - 1 To 0 Step -1
  If Rslt(I) = 40 Then GetOperPrior = GetOperPrior + 256
  If Rslt(I) = 41 Then GetOperPrior = GetOperPrior - 256
Next I
End Function
Private Sub FindEF()
'EFlags
'0 -  
'1 - 
'2 - 
'3 - 
'4 - 
'5 - /
Dim I&, C As Byte, IC As Byte
For I = 0 To RsltLen - 1
  If IC > 0 Then
    EF(I) = 0
    IC = IC + 1
    If IC > 3 Then IC = 0
  Else
    Select Case Rslt(I)
    Case 48 To 57, 46, 35 ' "0"-"9", ".", "#"
      If Rslt(I) = 35 Then
        EF(I) = 1
        IC = 1
      ElseIf Rslt(I) = 46 Then
        EF(I) = 1
      Else
        If I = 0 Then
          EF(I) = 1
        Else
          If EF(I - 1) = 4 Then
            EF(I) = 4
          Else
            EF(I) = 1
          End If
        End If
      End If
    Case 40 To 41 ' "(", ")"
      EF(I) = 3
    Case 45 ' "-"
      If I = 0 Then
        EF(I) = 1
      Else
        If EF(I - 1) = 1 Then
          If Rslt(I - 1) = 69 Or Rslt(I - 1) = 101 Then EF(I) = 1 Else EF(I) = 2
        ElseIf EF(I - 1) = 4 Or Rslt(I - 1) = 41 Then
          EF(I) = 2
        Else
          EF(I) = 1
        End If
      End If
    Case 43 ' "+"
      If EF(I - 1) = 1 And (Rslt(I - 1) = 69 Or Rslt(I - 1) = 101) Then EF(I) = 1 Else EF(I) = 2
    Case 65 To 90, 95, 97 To 122 ' "A"-"Z", "_", "a"-"z"
      If (Rslt(I) = 69 Or Rslt(I) = 101) And I > 0 Then
        If EF(I - 1) = 1 Then EF(I) = 1 Else EF(I) = 4
      Else
        EF(I) = 4
      End If
    Case Else
      EF(I) = 2
    End Select
  End If
Next I
C = 1
For I = RsltLen - 1 To 0 Step -1
  If EF(I) = 2 Then C = 1
  If Rslt(I) = 40 Then C = 0
  If EF(I) = 4 And C = 1 Then EF(I) = 5
Next I
End Sub

Function SolveVal(S$) As Double
Dim I&, R$
ExprLen = Len(S)
For I = 0 To ExprLen - 1
  Expr(I) = Asc(Mid(S, I + 1, 1))
Next I
Solve
For I = 0 To RsltLen - 1
  R = R + Chr(Rslt(I))
Next I
If ValidResult Then SolveVal = Val(R) Else SolveVal = 0
End Function

Function dRadToDeg(ByVal Num As Double) As Double
dRadToDeg = Num * pi_Prop
End Function
Function dDegToRad(ByVal Num As Double) As Double
dDegToRad = Num / pi_Prop
End Function
